"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TestRenderer = exports.TestSnapshot = exports.ShouldReturnBoolean = exports.FilterFuncName = exports.FailingExample = exports.VerboseExample = exports.SumOfNumbers = exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/asyncToGenerator"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/slicedToArray"));

var _react = _interopRequireWildcard(require("react"));

var _Describe = require("./components/Describe");

var _Test = require("./components/Test");

var _Expect = require("./components/Expect");

var _utility = require("./utility");

var _reactTestRenderer = require("react-test-renderer");

var _react2 = require("@testing-library/react");

var _ReactTestRenderer = require("./components/ReactTestRenderer");

var _When = require("./components/When");

var _TestingLibraryReact = require("./components/TestingLibraryReact");

var _default = {
  title: 'Example'
}; // Example function to be tested.

exports["default"] = _default;

function add(a, b) {
  if (Number.isNaN(a) || Number.isNaN(b)) {
    throw new Error('Invalid argument passed');
  }

  if (a === 10) {
    throw new Error('Not this number'); // This will be caught in coverage report
  }

  return a + b;
}

var _ref =
/*#__PURE__*/
_react["default"].createElement("h2", null, "Sum of numbers example");

var _ref2 =
/*#__PURE__*/
_react["default"].createElement("p", null, "Here's the source code for this particular example.");

var _ref3 =
/*#__PURE__*/
_react["default"].createElement("p", null, "You can start writing tests in React for this in your stories.");

var _ref4 =
/*#__PURE__*/
_react["default"].createElement("h3", null, "Output results:");

var SumOfNumbers = function SumOfNumbers() {
  return _react["default"].createElement("div", null, _ref, _ref2, _react["default"].createElement("code", null, _react["default"].createElement("pre", {
    style: {
      background: '#eee',
      padding: 15
    }
  }, add.toString())), _ref3, _react["default"].createElement("code", null, _react["default"].createElement("pre", {
    style: {
      background: '#eee',
      padding: 15
    }
  }, "export const SumOfNumbers = () => (\n  <Describe name=\"Adding sum of numbers\">\n    <Test name=\"When given a sum of 1 plus 1, the expected value is two, because maths\">\n      <Expect toEqual={2}>{add(1, 1)}</Expect>\n      <Expect toEqual={2} toBeGreaterThan={1} toBeLessThan={3}>\n        {add(1, 1)}\n      </Expect>\n    </Test>\n    <Test name=\"However, the following values will throw:\">\n      <Expect toThrow>{() => add(NaN, 1)}</Expect>\n      <Expect toThrow>{() => add(NaN, NaN)}</Expect>\n      <Expect toThrow>{() => add(1, NaN)}</Expect>\n    </Test>\n  </Describe>\n);")), _ref4, _react["default"].createElement(_Describe.Describe, {
    name: "Adding sum of numbers"
  }, _react["default"].createElement(_Test.Test, {
    name: "When given a sum of 1 plus 1, the expected value is two, because maths"
  }, _react["default"].createElement(_Expect.Expect, {
    toEqual: 2
  }, add(1, 1)), _react["default"].createElement(_Expect.Expect, {
    toEqual: 2,
    toBeGreaterThan: 1,
    toBeLessThan: 3
  }, add(1, 1))), _react["default"].createElement(_Test.Test, {
    name: "However, the following values will throw:"
  }, _react["default"].createElement(_Expect.Expect, {
    toThrow: true
  }, function () {
    return add(NaN, 1);
  }), _react["default"].createElement(_Expect.Expect, {
    toThrow: true
  }, function () {
    return add(NaN, NaN);
  }), _react["default"].createElement(_Expect.Expect, {
    toThrow: true
  }, function () {
    return add(1, NaN);
  }))));
};

exports.SumOfNumbers = SumOfNumbers;

var VerboseExample = function VerboseExample() {
  return _react["default"].createElement(_Describe.Describe, {
    verbose: true,
    name: "Adding sum of numbers (with verbose prop)"
  }, _react["default"].createElement(_Test.Test, {
    name: "When given a sum of 1 plus 1, the expected value is two, because maths"
  }, _react["default"].createElement(_Expect.Expect, {
    toEqual: 2
  }, add(1, 1)), _react["default"].createElement(_Expect.Expect, {
    toEqual: 2,
    toBeGreaterThan: 1,
    toBeLessThan: 3
  }, add(1, 1))), _react["default"].createElement(_Test.Test, {
    name: "However, the following values will throw:"
  }, _react["default"].createElement(_Expect.Expect, {
    toThrow: true
  }, function () {
    return add(NaN, 1);
  }), _react["default"].createElement(_Expect.Expect, {
    toThrow: true
  }, function () {
    return add(NaN, NaN);
  }), _react["default"].createElement(_Expect.Expect, {
    toThrow: true
  }, function () {
    return add(1, NaN);
  })));
};

exports.VerboseExample = VerboseExample;

var FailingExample = function FailingExample() {
  return _react["default"].createElement("div", null, _react["default"].createElement(_Describe.Describe, {
    name: "Failing example of a test"
  }, _react["default"].createElement(_Test.Test, {
    name: "This is marked as throwing, but will not throw."
  }, _react["default"].createElement(_Expect.Expect, {
    toThrow: true
  }, function () {
    return add(1, 1);
  }))), "Note: this test is not imported into the Jest test runner.");
};

exports.FailingExample = FailingExample;

var FilterFuncName = function FilterFuncName() {
  return _react["default"].createElement(_Describe.Describe, {
    name: "filterFuncName"
  }, _react["default"].createElement(_Test.Test, {
    name: "It will remove functions"
  }, _react["default"].createElement(_Expect.Expect, {
    toEqual: 'someCall(1, 2, 3);'
  }, (0, _utility.filterFuncName)('function () { return someCall(1, 2, 3); }'))), _react["default"].createElement(_Test.Test, {
    name: "It will leave named functions unchanged"
  }, _react["default"].createElement(_Expect.Expect, {
    not: true,
    toEqual: 'someCall(1, 2, 3);'
  }, (0, _utility.filterFuncName)('function someName() { return someCall(1, 2, 3); }'))), _react["default"].createElement(_Test.Test, {
    name: "It will ignore invalid input"
  }, _react["default"].createElement(_Expect.Expect, {
    toEqual: 'SOME INVALID INPUT'
  }, (0, _utility.filterFuncName)('SOME INVALID INPUT'))));
};

exports.FilterFuncName = FilterFuncName;

var _ref5 =
/*#__PURE__*/
_react["default"].createElement("h1", null, "Should return boolean tests");

var _ref6 =
/*#__PURE__*/
_react["default"].createElement("p", null, "This test is part of the library itself");

var ShouldReturnBoolean = function ShouldReturnBoolean() {
  return _react["default"].createElement("div", null, _ref5, _ref6, _react["default"].createElement(_Describe.Describe, {
    name: "shouldReturnBoolean"
  }, _react["default"].createElement(_Test.Test, {
    name: "should be false when using toThrow property"
  }, _react["default"].createElement(_Expect.Expect, {
    toEqual: false
  }, (0, _utility.shouldReturnBoolean)('toThrow', false))), _react["default"].createElement(_Test.Test, {
    name: "should be true for all other properties"
  }, ['toEqual', 'toBeCloseTo'].map(function (value) {
    return _react["default"].createElement(_Expect.Expect, {
      toEqual: true,
      variant: value,
      key: value
    }, (0, _utility.shouldReturnBoolean)(value, 'something'));
  })), _react["default"].createElement(_Test.Test, {
    name: "Allow variables to be passed with <When />"
  }, _react["default"].createElement(_When.When, {
    test: "Testing"
  }, function (props) {
    return _react["default"].createElement(_Expect.Expect, {
      toEqual: 'Testing'
    }, props.test);
  }))));
};

exports.ShouldReturnBoolean = ShouldReturnBoolean;

var TestSnapshot = function TestSnapshot() {
  return _react["default"].createElement(_Describe.Describe, {
    name: "snapshot"
  }, _react["default"].createElement(_Test.Test, {
    name: "test snapshot"
  }, _react["default"].createElement(_Expect.Expect, {
    toMatchSnapshot: true
  }, {
    test: 'testing'
  })));
};

exports.TestSnapshot = TestSnapshot;

var ExampleComponent = function ExampleComponent() {
  var _useState = (0, _react.useState)(0),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      count = _useState2[0],
      setCount = _useState2[1];

  return _react["default"].createElement("div", null, _react["default"].createElement("span", null, "Counter: ", count), _react["default"].createElement("button", {
    onClick: function onClick() {
      return setCount(function (n) {
        return n + 1;
      });
    }
  }, "Increment"));
};

var _ref7 =
/*#__PURE__*/
_react["default"].createElement(ExampleComponent, null);

var _ref8 =
/*#__PURE__*/
_react["default"].createElement(ExampleComponent, null);

var TestRenderer = function TestRenderer() {
  return _react["default"].createElement(_Describe.Describe, {
    name: "Integrations with other libraries",
    verbose: true
  }, _react["default"].createElement(_Test.Test, {
    name: "React test renderer"
  }, _react["default"].createElement(_ReactTestRenderer.ReactTestRenderer, {
    create: _ref7
  }, function (component) {
    (0, _reactTestRenderer.act)(function () {
      // Click twice.
      component.root.findByType('button').props.onClick();
      component.root.findByType('button').props.onClick();
    });
    return _react["default"].createElement(_Expect.Expect, {
      toEqual: '2'
    }, component.root.findByType('span').children[1]);
  })), _react["default"].createElement(_Test.Test, {
    name: "React testing library"
  }, _react["default"].createElement(_TestingLibraryReact.ReactComponent, {
    render: _ref8
  },
  /*#__PURE__*/
  function () {
    var _ref9 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee(result, fireEvent) {
      var button, count;
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return result.findByText('Increment');

            case 2:
              button = _context.sent;
              fireEvent.click(button);
              fireEvent.click(button);
              _context.next = 7;
              return result.findByText(/Counter: [0-9]+/);

            case 7:
              count = _context.sent;
              return _context.abrupt("return", _react["default"].createElement(_react["default"].Fragment, null, _react["default"].createElement(_Expect.Expect, {
                toBeTruthy: true
              }, button), _react["default"].createElement(_Expect.Expect, {
                toBeTruthy: true
              }, count), _react["default"].createElement(_Expect.Expect, {
                toContain: "Counter: 2"
              }, (0, _react2.getNodeText)(count))));

            case 9:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function (_x, _x2) {
      return _ref9.apply(this, arguments);
    };
  }())));
};

exports.TestRenderer = TestRenderer;